'use strict';

HLL('module:headland.postgres.QueryBuilder.js', function () {
	HL.loaded(['headland', 'postgres', 'QueryBuilder'], CL.fun(regeneratorRuntime.mark(function _callee2(CL, HL, $$module) {
		var _2, QueryBuilder;

		return regeneratorRuntime.wrap(function _callee2$(_context2) {
			while (1) {
				switch (_context2.prev = _context2.next) {
					case 0:
						_2 = void 0;
						QueryBuilder = HL.Class.extend({
							name: ['headland', 'postgres', 'QueryBuilder'],
							mode: 'shared',
							fields: {
								text: {
									initializer: function initializer() {
										return [];
									}
								},
								values: {
									initializer: function initializer() {
										return [];
									}
								},
								nextId: {
									value: 1
								},
								init: {
									method: function method(arg) {
										var _private = this['private:headland.postgres.QueryBuilder'];

										this.push(arg);
									}
								},
								push: {
									method: function method() {
										var _private = this['private:headland.postgres.QueryBuilder'];

										for (var i = 0; i < arguments.length; i++) {
											var arg = arguments[i];
											var arr = _2.isArray(arg) ? arg : [arg];
											for (var _i = 0; _i < arr.length; _i++) {
												var item = arr[_i];
												if (typeof item == 'string') {
													_private.text.push(item);
												} else if (item instanceof QueryBuilder.Raw) {
													if (_2.isArray(item.value)) {
														for (var j = 0; j < item.value.length; j++) {
															var rs = item.value[j];
															if (_2.isArray(rs)) {
																_private.text.push('$' + _private.nextId++);
																_private.values.push(rs[0]);
															} else {
																_private.text.push(rs);
															}
														}
													} else {
														_private.text.push(item.value);
													}
												} else if (item.length == 1) {
													_private.text.push('$' + _private.nextId++);
													_private.values.push(item[0]);
												} else {
													console.log(item);
													CL.throw('HLPostgreSQLQueryBuilder', 'Wrong query parameter');
												}
											}
										}
									}
								},
								get: {
									method: function method() {
										var _private = this['private:headland.postgres.QueryBuilder'];

										return {
											text: _private.text.join(' '),
											values: _private.values
										};
									}
								}
							},
							privateFields: {},
							statics: {},
							privateStatics: {}
						});
						QueryBuilder.Raw = HL.Class.extend({
							name: ['headland', 'postgres', 'QueryBuilder', 'Raw'],
							mode: 'shared',
							fields: {
								value: {},
								init: {
									method: function method(value) {
										var _private = this['private:headland.postgres.QueryBuilder.Raw'];

										_private.value = value;
									}
								}
							},
							privateFields: {},
							statics: {},
							privateStatics: {}
						});
						$$module.export(QueryBuilder);
						$$module.loadDeferred(regeneratorRuntime.mark(function _callee() {
							return regeneratorRuntime.wrap(function _callee$(_context) {
								while (1) {
									switch (_context.prev = _context.next) {
										case 0:
											_context.next = 2;
											return HL.require('lodash', false, true);

										case 2:
											_2 = _context.sent;

										case 3:
										case 'end':
											return _context.stop();
									}
								}
							}, _callee, this);
						}));

					case 5:
					case 'end':
						return _context2.stop();
				}
			}
		}, _callee2, this);
	})), {
		immediate: [],
		deferred: ['lodash']
	});
});
//# sourceMappingURL=/@/es5/headland.postgres.QueryBuilder.js.map
